Subject: Re: bug#54914: 28.1.50; Unable to form Brahmi conjuncts in Emacs

From: समीर सिंह Sameer Singh<[email-masked]>
Date: Wed, 13 Apr 2022 23:36:02 +0530

I am not capable enough to write my own patch for it, but will be more than
happy to provide help in implementing it, by validating results.

On Wed, Apr 13, 2022 at 10:26 PM Robert Pluim <[email-masked]> wrote:

> >>>>> On Wed, 13 Apr 2022 19:03:36 +0300, Eli Zaretskii <[email-masked]>
> said:
>
>     >> From: Sameer Singh <[email-masked]>
>     >> Date: Wed, 13 Apr 2022 16:25:41 +0530
>     >>
>     >> Brahmi just like any other Indic script also has the ability to
> form conjuncts, but despite using "Segoe UI
>     >> Historic" font which supports Brahmi Conjuncts, Emacs is not able
> to display them.
>
>     Eli> This is a missing feature: we don't have composition rules for the
>     Eli> Brahmi script, and more generally don't have any support for that
>     Eli> script.  Patches to add that are welcome.
>
> A brute-force example of what Eli's talking about would be:
>
> (set-char-table-range composition-function-table
>                       '(#x11000 . #x1107F)
>                       (list (vector "[\x11000-\x1107F]+" 0
> #'font-shape-gstring)))
>
> which essentially means "hand off any sequence of Brahmi codepoints to
> harfbuzz", which might end up being slow. From your example, youʼre
> requesting more something like "consonant, virami, consonant", which
> is also possible, but we'll need your guidance to tell us when the
> results are acceptable. (If anyone is interested, thereʼs section 14.1
> of the Unicode 14 standard that describes how they think Brahmi should
> be handled, but Iʼve not tried to understand it yet).
>
> Robert
> --
>